#include "mmc.h"
#include "lcd.h"
#include "types.h"

struct fat_filedata_st {
	u32 len;
	u16 startcl;
#ifdef DIR_SUPPORT
    u32 dirsect;
#else
	u16 dirsect;
#endif
	u08 dirsectoffs;
	u08 entries; // LFN => entries > 1
#ifdef DIR_SUPPORT
	u08 attr;
#endif
	u08 name[LINESIZE];
};

#define FILEMODE_CLOSED 0
#define FILEMODE_READ 1
#define FILEMODE_WRITE 2

#define ATTR_DIRECTORY 0x10

// functions
u08 fat_init();
void print_filename(u08 y);
void print_filesize(void);
void fat_count_files(void);
u08 fat_read_filedata(u08 nr);	// new file data in global struct
void fat_delete_file(void);
u08 fat_openfile(u08 mode, u08 nr);
u08 fat_closefile(void);
u08 fat_getnextsector(void);
#ifdef DIR_SUPPORT
    bool fat_enter_dir(void);
    bool fat_leave_dir(void);
#endif
u32 cluster2sector(u16 c);
